package com.realnet.taxi_rental.Controllers;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import com.fasterxml.jackson.core.JsonProcessingException;
import org.springframework.web.bind.annotation.CrossOrigin;
import com.fasterxml.jackson.databind.JsonMappingException;
import com.realnet.config.EmailService;
import com.realnet.users.entity1.AppUser;
import com.realnet.users.service1.AppUserServiceImpl;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.springframework.data.domain.*;
import com.realnet.fnd.response.EntityResponse;
import org.springframework.http.*;
import org.springframework.beans.factory.annotation.*;
import com.realnet.taxi_rental.Entity.Products;
import com.realnet.taxi_rental.Services.ProductsService ;












@RequestMapping(value = "/Products")
 @CrossOrigin("*") 
@RestController
public class ProductsController {
	@Autowired
	private ProductsService Service;

@Value("${projectPath}")
	private String projectPath;
 












	@PostMapping("/Products")
		  public Products Savedata(@RequestBody Products data) {
		Products save = Service.Savedata(data)	;











		System.out.println("data saved..." + save);

 return save;
	  }
@PutMapping("/Products/{id}")
	public  Products update(@RequestBody Products data,@PathVariable Integer id ) {
		Products update = Service.update(data,id);
		System.out.println("data update..." + update);
		return update;
	}	 
//	get all with pagination
	@GetMapping("/Products/getall/page")
	public Page<Products> getall(@RequestParam(value = "page", required = false) Integer page,
			@RequestParam(value = "size", required = false) Integer size) {
		Pageable paging = PageRequest.of(page, size);
		Page<Products> get = Service.getAllWithPagination(paging);

		return get;

	}	
	@GetMapping("/Products")
	public List<Products> getdetails() {
		 List<Products> get = Service.getdetails();		
		return get;
}
// get all without authentication 

	@GetMapping("/token/Products")
	public List<Products> getallwioutsec() {
		 List<Products> get = Service.getdetails();		
		return get;
}
@GetMapping("/Products/{id}")
	public  Products  getdetailsbyId(@PathVariable Integer id ) {
		Products  get = Service.getdetailsbyId(id);
		return get;
	}
@DeleteMapping("/Products/{id}")
	public  ResponseEntity<?> delete_by_id(@PathVariable Integer id ) {
	Service.delete_by_id(id);
			return new ResponseEntity<>(new EntityResponse("Deleted"), HttpStatus.OK);
	
	}













}